=== debian/changelog ===
gnss-sdr (0.0.11-2build6) focal; urgency=medium

  * No-change rebuild against new gr-osmosdr.

 -- Logan Rosen <logan@ubuntu.com>  Sat, 29 Feb 2020 18:12:24 -0500

gnss-sdr (0.0.11-2build5) focal; urgency=medium

  * No-change rebuild for gnuradio soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Feb 2020 11:35:15 +0100

gnss-sdr (0.0.11-2build4) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 12 Feb 2020 23:17:59 +0000

gnss-sdr (0.0.11-2build3) focal; urgency=medium

  * Rebuild against new libuhd3.15.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Jan 2020 16:31:42 +0100

gnss-sdr (0.0.11-2build2) focal; urgency=medium

  * Rebuild against new gnuradio 3.8.0.0-7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 20 Jan 2020 11:45:09 +0100

gnss-sdr (0.0.11-2build1) focal; urgency=medium

  * No-change rebuild against libmatio9

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Nov 2019 23:23:03 +0000

gnss-sdr (0.0.11-2) unstable; urgency=medium

  * Add patch for gr-iio 0.3-6 (closes: #940063)
  * Add patch for finding dependencies in riscv64 arch
  * Fix variable tracking size limit error in some archs

 -- Carles Fernandez <carles.fernandez@cttc.es>  Tue, 03 Sep 2019 19:19:49 +0200

gnss-sdr (0.0.11-1) unstable; urgency=medium

  * First release of upstream version 0.0.11
  * Standards-Version updated to 4.4.0.0
  * Removed debian/compat file, added debhelper-compat (= 12) in control file
  * Update copyright file with new code additions and copyright years
  * Add Protocol Buffers dependencies (libprotobuf-dev, protobuf-compiler)

 -- Carles Fernandez <carles.fernandez@cttc.es>  Sun, 04 Aug 2019 22:55:52 +0100
