=== debian/watch ===
version=3

opts="filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gnss-sdr-$1\.tar\.gz/,pgpsigurlmangle=s/archive\/v(\d\S*)\.tar\.gz/releases\/download\/v$1\/gnss-sdr-$1.tar.gz.asc/,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,dversionmangle=s/\+(debian|dsfg|ds|deb)(\.\d+)?$//" https://github.com/gnss-sdr/gnss-sdr/tags .*/v?(\d\S.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

# if tweaking of source is needed
# \
# debian debian/get-orig-source

# if you need to repack and choose +dfsg prefix
# opts=dversionmangle=s/[~\+]dfsg[0-9]*// \
#
